Subject: bug#47678: 27.1; `completion-boundaries` assertion failure for file

From: Stefan Monnier <[email-masked]>
Date: Sun, 09 May 2021 09:37:44 -0400

> Thank you for the clarification. I agree. A while ago when fiddling with
> file based commands I had wondered why completing-read or the UI can
> even return shadowed paths leading to complications down the road. A
> canonicalize method would be a good way to achieve this generically. Are
> there more examples where one would want to do such a canonicalization?

Good question.  I can imagine it being used in a few other "file-like"
completion tables (e.g. MH mailboxes), but it doesn't seem nearly as
useful.  There might also be some possible uses in a context of quoting
where it could return the string but quoted in a "canonical way"
(e.g. for file names, it could maybe double the lone `$` signs that
happen not to match any env-var, or add {...} around the env-vars), ...

But no, none of those are very compelling candidates.
For this reason, the current hack lives on.

> What do you mean by "providing a method"?

Nothing specific.

        Stefan